/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest{}

// AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest struct for AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest
type AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest struct {
	Service *string                              `json:"service,omitempty"`
	Data    *GoogleAnalytics4StaticDtoAuthorizer `json:"data,omitempty"`
}

// NewAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest instantiates a new AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest() *AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest {
	this := AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest{}
	var service string = "google_analytics4_static"
	this.Service = &service
	return &this
}

// NewAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequestWithDefaults instantiates a new AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequestWithDefaults() *AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest {
	this := AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest{}
	var service string = "google_analytics4_static"
	this.Service = &service
	return &this
}

// GetService returns the Service field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) GetService() string {
	if o == nil || IsNil(o.Service) {
		var ret string
		return ret
	}
	return *o.Service
}

// GetServiceOk returns a tuple with the Service field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) GetServiceOk() (*string, bool) {
	if o == nil || IsNil(o.Service) {
		return nil, false
	}
	return o.Service, true
}

// HasService returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) HasService() bool {
	if o != nil && !IsNil(o.Service) {
		return true
	}

	return false
}

// SetService gets a reference to the given string and assigns it to the Service field.
func (o *AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) SetService(v string) {
	o.Service = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) GetData() GoogleAnalytics4StaticDtoAuthorizer {
	if o == nil || IsNil(o.Data) {
		var ret GoogleAnalytics4StaticDtoAuthorizer
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) GetDataOk() (*GoogleAnalytics4StaticDtoAuthorizer, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given GoogleAnalytics4StaticDtoAuthorizer and assigns it to the Data field.
func (o *AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) SetData(v GoogleAnalytics4StaticDtoAuthorizer) {
	o.Data = &v
}

func (o AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Service) {
		toSerialize["service"] = o.Service
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	return toSerialize, nil
}

type NullableAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest struct {
	value *AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest
	isSet bool
}

func (v NullableAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) Get() *AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest {
	return v.value
}

func (v *NullableAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) Set(val *AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest(val *AppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) *NullableAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest {
	return &NullableAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerGoogleAnalytics4StaticGoogleAnalytics4StaticAuthorizerNewRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
